import java.util.ArrayList;

public class CalculateArea {
    ArrayList<Double> Pointx_input;
    ArrayList<Double> Pointy_input;
    ArrayList<Double> Row_input;
    ArrayList<Double> Theta_input;
    ArrayList<Double> centerx_history;
    ArrayList<Double> centery_history;
    double FinalCenterX;
    double FinalCenterY;
    double RusedforMeanShift;

    public CalculateArea(ArrayList<Double> Pointx_input,ArrayList<Double> Pointy_input,ArrayList<Double> centerx_history,ArrayList<Double> centery_history){
        this.Pointx_input = Pointx_input;
        this.Pointy_input = Pointy_input;
        this.centerx_history = centerx_history;
        this.centery_history = centery_history;
    }

    public void setRusedforMeanShift(double RusedforMeanShift){
        this.RusedforMeanShift = RusedforMeanShift;
    }

    public void DktoPolar(){
        for(int i = 0 ;i < Pointx_input.size();i++){
            double Theta = 0;
            Double R = Math.sqrt(Math.pow(Pointx_input.get(i),2) + Math.pow(Pointy_input.get(i),2));
            Theta = CalculateTheta(Pointx_input.get(i),Pointy_input.get(i),R);
            Row_input.add(R);
            Theta_input.add(Theta);
        }
    }

    public double CalculateTheta(Double x ,Double y ,Double row){
        double Theta = 0;
        if( y > 0 ){
            Theta = Math.acos(x/row);
        }
        else if( y < 0 ){
            Theta = 2 * Math.PI - Math.acos(x/row);
        }
        return Theta;
    }

    public Integer Compare(double R){
        double Max = 0 ;
        int IndexofMax = 0;
        for(int i = 0 ; i < centerx_history.size(); i++ ){
            if(FindPointinsideR(centerx_history.get(i),centery_history.get(i),R) > Max){
//                Max = FindPointinsideR(centerx_history.get(i),centery_history.get(i),R);
                IndexofMax = i;
            }
        }
        return IndexofMax;
    }

    public void configFinalCircle(){
        int IndexofMax;
        IndexofMax = Compare(RusedforMeanShift)
        FinalCenterX = centerx_history.get(IndexofMax);
        FinalCenterY = centery_history.get(IndexofMax);
    }

    public double FindPointinsideR(double centerx,double centery,double R){
        ArrayList<Integer> NuminsideR = new ArrayList<>();
        for(int i = 0 ; i < Pointx_input.size() ; i++){
            if (CalculateDistance(Pointx_input.get(i),Pointy_input.get(i),centerx,centery) < R){
                NuminsideR.add(i);
            }
        }
        return NuminsideR.size();
    }

    public double CalculateDistance(Double x1,Double y1, Double x2 ,Double y2){
        return Math.sqrt(Math.pow((x1-x2),2) + Math.pow((y1-y2),2));
    }


}
